set -e em um subshell

7

Eu achei que set -e teve o mesmo efeito em subshells como no shell de nível superior. Aparentemente, isso não acontece. Isso:

(
  set -e
  false 
  true
) || echo false1


bash -ec '
  set -e
  false 
  true
' || echo false2


bash <<EOF || echo false3
  set -e
  false 
  true
EOF

bash <<EOF || echo false4
  false 
  true
EOF

bash <<EOF || echo false5
  false  &&
  true
EOF

Impressões

false2
false3
false5

Onde isso é documentado? Posso obter subshells para terminar em erros, sem conectar todos os seus comandos com && (ou sem fazer || exit $? após cada comando)?

Editar:

Meu caso de uso específico foi algo como:

set -e
  # ...
status=0
( false; true ) || status=$?
report_code $status
return $status

Onde o conteúdo do subshell era meu código real. O problema com isso é sempre define o status como 0 e substituindo || com ; causa uma saída de erro indesejada por causa do conjunto externo -e.

Eu resolvi isso com:

set -e
  # ...
set +e
( false; true ); status=$?
set -e
report_code $status
return $status

Eu gostaria de não ter feito isso, mas parece que todos os shells comuns mostram isso dicotomia entre exec e subshell versus subfamília justa:

#!/bin/sh

echo FORK\'D:
export SH
for SH in dash bash ksh zsh; do
    $SH -c 'st=0; ( set -e; false; true ) || st=$?; printf "%s\t%s\n" $SH  $st; '
done

echo EXEC\'D:
for SH in dash bash ksh zsh; do
    $SH -c 'st=0; '$SH' -c " set -e; false; true " || st=$?; printf "%s\t%s\n" $SH $st; '
done

OUTPUT:

FORK'D:
dash    0
bash    0
ksh 0
zsh 0
EXEC'D:
dash    1
bash    1
ksh 1
zsh 1
    
por PSkocik 18.07.2016 / 02:58

1 resposta

12

Observe:

$ ( set -e; false ; true ) || echo false1
$ ( set -e; false ; true ) ; echo code=$?
code=1

Além disso:

$ ( set -e; false ; true; echo inside=$? ) || echo false1
inside=0

Aparentemente, quando o subshell é seguido por um || , set -e não faz com que o subshell saia ao alcançar o comando false . Em vez disso, a subshell continua e executa true (e echo inside=$? ).

A filosofia de set -e é tipicamente que ela só é obtida após erros não detectados. Aqui, a presença de || fora do subshell parece dizer ao shell que o erro dentro do subshell é 'pego' e, portanto, set -e não causa uma saída após false .

set -e tem muitos comportamentos surpreendentes. Consulte "Por que não definir -e fazer o que eu esperado? "

Documentação

O comportamento acima é sugerido na documentação em man bash :

-e

Exit immediately if a pipeline (which may consist of a single simple command), a list, or a compound command (see SHELL GRAMMAR above), exits with a non-zero status. The shell does not exit if the command that fails is part of the command list immediately following a while or until keyword, part of the test following the if or elif reserved words, part of any command executed in a && or || list except the command following the final && or ||, any command in a pipeline but the last, or if the command's return value is being inverted with !. If a compound command other than a subshell returns a non-zero status because a command failed while -e was being ignored, the shell does not exit. A trap on ERR, if set, is executed before the shell exits. This option applies to the shell environment and each subshell environment separately (see COMMAND EXECUTION ENVIRONMENT above), and may cause subshells to exit before executing all the commands in the subshell. [Emphasis added.]

    
por 18.07.2016 / 04:06